//---------------------------------------------------------------------------
#include <math.h>
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "mpu6050registers.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//---------------------------------------------------------------------------
/*
 * read bytes from chip register
 */
unsigned char mpu6050_readBytes(unsigned char regAddr, unsigned char length)
{       unsigned char i = 0;
	unsigned count = 0;
	if(length > 0)
        {       //request register
                SendStart_I2C(PortHandle,0);
                        if(NEED_DETAILS==true)  Form1->RichEdit1->Lines->Add("     I2C_START");
                Temp8=(MPU6050_ADDR<<1)|0x00;
		SendByte_I2C(PortHandle,0,Temp8);
                        if(NEED_DETAILS==true)  Form1->RichEdit1->Lines->Add("     I2C_SEND_BYTE: 0x"+IntToHex(Temp8,2)+"   CHIP_ADDRESS<<1 | LSB=WRITE");
		SendByte_I2C(PortHandle,0,regAddr);
                        if(NEED_DETAILS==true)  Form1->RichEdit1->Lines->Add("     I2C_SEND_BYTE: 0x"+IntToHex(regAddr,2)+"   REGISTER_ADDRESS");
		//read data
		SendStart_I2C(PortHandle,0);
                        if(NEED_DETAILS==true)  Form1->RichEdit1->Lines->Add("     I2C_START");
                Temp8=(MPU6050_ADDR<<1)|0x01;
		SendByte_I2C(PortHandle,0,Temp8);
                        if(NEED_DETAILS==true)  Form1->RichEdit1->Lines->Add("     I2C_SEND_BYTE: 0x"+IntToHex(Temp8,2)+"   CHIP_ADDRESS<<1 | LSB=READ");
		for(i=0; i<length; i++)
                {       count++;
			if(i==length-1)
                        {       TempBytes = ReadByte_I2C(PortHandle);
                                TempReadBuffer[i]=TempBytes.Buffer[0];
                                        if(NEED_DETAILS==true)  Form1->RichEdit1->Lines->Add("     I2C_READ_BYTE: 0x"+IntToHex(TempBytes.Buffer[0],2));
                        }
			else
                        {       TempBytes = ReadByteA_I2C(PortHandle);
				TempReadBuffer[i]=TempBytes.Buffer[0];
                                        if(NEED_DETAILS==true)  Form1->RichEdit1->Lines->Add("     I2C_READ_BYTE(ACK): 0x"+IntToHex(TempBytes.Buffer[0],2));
                        }
		}
		SendStop_I2C(PortHandle,0);
                        if(NEED_DETAILS==true)  Form1->RichEdit1->Lines->Add("     I2C_STOP");
	}
	return count;
}
//---------------------------------------------------------------------------
/*
 * read 1 byte from chip register
 */
unsigned char   mpu6050_readByte(unsigned char regAddr)
{       return  mpu6050_readBytes(regAddr, 1);
}
//---------------------------------------------------------------------------
/*
 * write bytes to chip register
 */
void mpu6050_writeBytes(unsigned char regAddr, unsigned char length)
{       if(length > 0)
        {       //write data
                SendStart_I2C(PortHandle,0);
                        if(NEED_DETAILS==true)  Form1->RichEdit1->Lines->Add("     I2C_START");
                Temp8=(MPU6050_ADDR<<1)|0x00;
		SendByte_I2C(PortHandle,0,Temp8);
                        if(NEED_DETAILS==true)  Form1->RichEdit1->Lines->Add("     I2C_SEND_BYTE: 0x"+IntToHex(Temp8,2)+"   CHIP_ADDRESS<<1 | LSB=WRITE");
		SendByte_I2C(PortHandle,0,regAddr);
                        if(NEED_DETAILS==true)  Form1->RichEdit1->Lines->Add("     I2C_SEND_BYTE: 0x"+IntToHex(regAddr,2)+"   REGISTER_ADDRESS");
		for (unsigned char i = 0; i < length; i++)
                {       SendByte_I2C(PortHandle,0,TempWriteBuffer[i]);
                                if(NEED_DETAILS==true)  Form1->RichEdit1->Lines->Add("     I2C_SEND_BYTE: 0x"+IntToHex(TempWriteBuffer[i],2));
		}
		SendStop_I2C(PortHandle,0);
                        if(NEED_DETAILS==true)  Form1->RichEdit1->Lines->Add("     I2C_STOP");
	}
}
//---------------------------------------------------------------------------
/*
 * write 1 byte to chip register
 */
void mpu6050_writeByte(unsigned char regAddr, unsigned char data)
{       TempWriteBuffer[0]=data;
        mpu6050_writeBytes(regAddr, 1);
}
//---------------------------------------------------------------------------
/*
 * read bits from chip register
 */
unsigned char mpu6050_readBits(unsigned char regAddr, unsigned char bitStart, unsigned char length)
{       // 01101001 read byte
        // 76543210 bit numbers
        //    xxx   args: bitStart=4, length=3
        //    010   masked
        //   -> 010 shifted
        unsigned char count = 0;
        if(length > 0)
        {       count = mpu6050_readByte(regAddr);
		if (count != 0)
                {       unsigned char b = TempReadBuffer[0];
			unsigned char mask = ((1 << length) - 1) << (bitStart - length + 1);
			b &= mask;
			b >>= (bitStart - length + 1);
			Temp8 = b;
		}
        }
        return count;
}
//---------------------------------------------------------------------------
/*
 * read 1 bit from chip register
 */
unsigned char mpu6050_readBit(unsigned char regAddr, unsigned char bitNum)
{       unsigned char count = mpu6050_readByte(regAddr);
        if(count  !=0)
        {        unsigned char b=TempReadBuffer[0];
                 b &= (1 << bitNum);
                 Temp8 = b;
        }
        return count;
}
//---------------------------------------------------------------------------
/*
 * write bit/bits to chip register
 */
void mpu6050_writeBits(unsigned char regAddr, unsigned char bitStart, unsigned char length, unsigned char data)
{       //      010 value to write
        // 76543210 bit numbers
        //    xxx   args: bitStart=4, length=3
        // 00011100 mask byte
        // 10101111 original value (sample)
        // 10100011 original & ~mask
        // 10101011 masked | value
	if(length > 0)
        {       if (mpu6050_readByte(regAddr) != 0)
                {       //get current data
                        unsigned char b = TempReadBuffer[0];
			unsigned char mask = ((1 << length) - 1) << (bitStart - length + 1);
			data <<= (bitStart - length + 1);       // shift data into correct position
			data &= mask;   // zero all non-important bits in data
			b &= ~(mask);   // zero all important bits in existing byte
			b |= data;      // combine data with existing byte
			mpu6050_writeByte(regAddr, b);
		}
	}
}
//---------------------------------------------------------------------------
/*
 * write one bit to chip register
 */
void mpu6050_writeBit(unsigned char regAddr, unsigned char bitNum, unsigned char data)
{       mpu6050_readByte(regAddr);
        unsigned char b = TempReadBuffer[0];
        if(data != 0)   b |= (1<<bitNum);       //    
        else            b &= ~(1<<bitNum);      //    
        mpu6050_writeByte(regAddr, b);
}
//---------------------------------------------------------------------------
/*
 * set a chip memory bank
 */
void mpu6050_setMemoryBank(unsigned char bank, unsigned char prefetchEnabled, unsigned char userBank)
{       bank &= 0x1F;
        if (userBank)           bank |= 0x20;
        if (prefetchEnabled)    bank |= 0x40;
        if(NeedLog)     Form1->RichEdit1->Lines->Add("setting a chip memory bank to 0x"+IntToHex(bank,2)+"...");
        mpu6050_writeByte(MPU6050_RA_BANK_SEL, bank);
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   complete");
}
//---------------------------------------------------------------------------
/*
 * set memory start address
 */
void mpu6050_setMemoryStartAddress(unsigned char address)
{       if(NeedLog)     Form1->RichEdit1->Lines->Add("setting a memory start address to 0x"+IntToHex(address,2)+"...");
        mpu6050_writeByte(MPU6050_RA_MEM_START_ADDR, address);
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   complete");
}
//---------------------------------------------------------------------------
/*
 * read a memory block
 */
void mpu6050_readMemoryBlock(unsigned short dataSize, unsigned char bank, unsigned char address)
{       if(NeedLog)     Form1->RichEdit1->Lines->Add("reading a memory block: size=0x"+IntToHex(dataSize,4)+" , bank=0x"+IntToHex(bank,2)+" , address=0x"+IntToHex(address,2)+"...");
        mpu6050_setMemoryBank(bank, 0, 0);
	mpu6050_setMemoryStartAddress(address);

        unsigned char chunkSize;

        for (unsigned short i = 0; i < dataSize;)
        {       // determine correct chunk size according to bank position and data size
                chunkSize = MPU6050_DMP_MEMORY_CHUNK_SIZE;

                // make sure we don't go past the data size
                if (i + chunkSize > dataSize)   chunkSize = dataSize - i;

                // make sure this chunk doesn't go past the bank boundary (256 bytes)
                if (chunkSize > 256 - address) chunkSize = 256 - address;

                // read the chunk of data as specified
                mpu6050_readBytes(MPU6050_RA_MEM_R_W, chunkSize);

                // copy readed data to TempBigBuffer
                for(unsigned short j=0; j<chunkSize; j++)
                        TempBigBuffer[i+j]=TempReadBuffer[j];

                // increase byte index by [chunkSize]
                i += chunkSize;

                // unsigned char automatically wraps to 0 at 256
                address += chunkSize;

                // if we aren't done, update bank (if necessary) and address
                if (i < dataSize)
                {       if (address == 0)       bank++;
                        mpu6050_setMemoryBank(bank, 0, 0);
                        mpu6050_setMemoryStartAddress(address);
                }
        }
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   reading a memory block complete!");
}
//---------------------------------------------------------------------------
/*
 * write a memory block
 */
unsigned char mpu6050_writeMemoryBlock(unsigned short dataSize, unsigned char bank, unsigned char address, unsigned char verify, unsigned char useProgMem)
{       if(NeedLog)     Form1->RichEdit1->Lines->Add("writing a memory block: size=0x"+IntToHex(dataSize,4)+" , bank=0x"+IntToHex(bank,2)+" , address=0x"+IntToHex(address,2)+"...");
	mpu6050_setMemoryBank(bank, 0, 0);
	mpu6050_setMemoryStartAddress(address);
        unsigned char chunkSize;

        unsigned short i;
        unsigned char j;
        AnsiString TempWRStr;

        for (i = 0; i < dataSize;)
        {       // determine correct chunk size according to bank position and data size
                chunkSize = MPU6050_DMP_MEMORY_CHUNK_SIZE;

                // make sure we don't go past the data size
                if (i + chunkSize > dataSize) chunkSize = dataSize - i;

                // make sure this chunk doesn't go past the bank boundary (256 bytes)
                if (chunkSize > 256 - address) chunkSize = 256 - address;

                // write the chunk of data as specified
                TempWRStr="writing chunk of data:";
                for (j = 0; j < chunkSize; j++)
                {       TempWriteBuffer[j] = TempBigBuffer[i+j];
                        TempWRStr += " 0x"+IntToHex(TempWriteBuffer[j],2);
                }
                if(NeedLog)     Form1->RichEdit1->Lines->Add(TempWRStr);
                mpu6050_writeBytes(MPU6050_RA_MEM_R_W, chunkSize);
                if(NeedLog)     Form1->RichEdit1->Lines->Add("   complete!");

                // verify data if needed
                if (verify)
                {       mpu6050_setMemoryBank(bank, 0, 0);
                        mpu6050_setMemoryStartAddress(address);
                        mpu6050_readBytes(MPU6050_RA_MEM_R_W, chunkSize);
                        TempWRStr="readed data for verify:";
                        for (j = 0; j < chunkSize; j++)
                                TempWRStr += " 0x"+IntToHex(TempReadBuffer[j],2);
                        if(NeedLog)     Form1->RichEdit1->Lines->Add(TempWRStr);
                }

                // increase byte index by [chunkSize]
                i += chunkSize;

                // unsigned char automatically wraps to 0 at 256
                address += chunkSize;

                // if we aren't done, update bank (if necessary) and address
                if (i < dataSize)
                {       if (address == 0)       bank++;
                        mpu6050_setMemoryBank(bank, 0, 0);
                        mpu6050_setMemoryStartAddress(address);
                }
        }
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   writing a memory block complete!");
        return 1;
}
//---------------------------------------------------------------------------
/*
 * write a dmp configuration set
 */
unsigned char mpu6050_writeDMPConfigurationSet(unsigned short dataSize, unsigned char useProgMem)
{       unsigned char success, special;
        unsigned short i, j;

        Form1->RichEdit1->Lines->Add("writing a config block: size=0x"+IntToHex(dataSize,4)+"...");

        // config set data is a long string of blocks with the following structure:
        // [bank] [offset] [length] [byte[0], byte[1], ..., byte[length]]
        unsigned char bank, offset, length;
        for (i = 0; i < dataSize;)
        {       bank = mpu6050_dmpConfig[i];
                i++;
                offset = mpu6050_dmpConfig[i];
                i++;
                length = mpu6050_dmpConfig[i];
                i++;

                // write data or perform special action
                if (length > 0)
                {       // regular block of data to write
                        for (j = 0; j < length; j++) TempBigBuffer[j] = mpu6050_dmpConfig[i + j];
                        success = mpu6050_writeMemoryBlock(length, bank, offset, 1, 0);
                        i += length;
                }
                else
                {       // special instruction
                        // NOTE: this kind of behavior (what and when to do certain things)
                        // is totally undocumented. This code is in here based on observed
                        // behavior only, and exactly why (or even whether) it has to be here
                        // is anybody's guess for now.
                        special = mpu6050_dmpConfig[i];
                        i++;
                        if (special == 0x01)
                        {       // enable DMP-related interrupts

                           	//mpu6050_writeBit(MPU6050_RA_INT_ENABLE, MPU6050_INTERRUPT_ZMOT_BIT, 1); //setIntZeroMotionEnabled
            	                //mpu6050_writeBit(MPU6050_RA_INT_ENABLE, MPU6050_INTERRUPT_FIFO_OFLOW_BIT, 1); //setIntFIFOBufferOverflowEnabled
                            	//mpu6050_writeBit(MPU6050_RA_INT_ENABLE, MPU6050_INTERRUPT_DMP_INT_BIT, 1); //setIntDMPEnabled
            	                mpu6050_writeByte(MPU6050_RA_INT_ENABLE, 0x32);  // single operation

                                success = 1;
                        }
                        else
                        {       // unknown special command
                                success = 0;
                                Form1->RichEdit1->Lines->Add("Unknown special command!");
                        }
                }
                if (!success)   return 0; // uh oh
        }
        Form1->RichEdit1->Lines->Add("   writing a config block complete!");
        return 1;
}
//---------------------------------------------------------------------------
/*
 * get the fifo count
 */
unsigned short mpu6050_getFIFOCount()
{       if(NeedLog)     Form1->RichEdit1->Lines->Add("getting FIFO count...");
        mpu6050_readBytes(MPU6050_RA_FIFO_COUNTH, 2);
        unsigned short  FIFOCount=(TempReadBuffer[0]<<8)|TempReadBuffer[1];
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   FIFO count = 0x"+IntToHex(FIFOCount,4));
        return FIFOCount;
}
//---------------------------------------------------------------------------
/*
 * read fifo bytes
 */
void mpu6050_getFIFOBytes(unsigned char length)
{       AnsiString TempStr="   FIFO bytes:";

        if(NeedLog)     Form1->RichEdit1->Lines->Add("reading "+IntToStr(length)+" FIFO bytes...");
        mpu6050_readBytes(MPU6050_RA_FIFO_R_W, length);
        if(NeedLog)     Form1->RichEdit1->Lines->Add("       FORMAT: [QUAT W ] [-------] [QUAT X ] [-------] [QUAT Y ] [-------] [QUAT Z ] [-------] [GYRO X ] [-------] [GYRO Y ] [-------] [GYRO Z ] [-------] [ACCEL X] [-------] [ACCEL Y] [-------] [ACCEL Z] [-------] [-------]");
        for(int i=0;i<length;i++)
                TempStr += " 0x"+IntToHex(TempReadBuffer[i],2);
        if(NeedLog)     Form1->RichEdit1->Lines->Add(TempStr);
}
//---------------------------------------------------------------------------
/*
 * get the interrupt status
 */
unsigned char mpu6050_getIntStatus()
{       if(NeedLog)     Form1->RichEdit1->Lines->Add("getting the interrupt status...");
        mpu6050_readByte(MPU6050_RA_INT_STATUS);
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   the interrupt status: 0x"+IntToHex(TempReadBuffer[0],2));
        return TempReadBuffer[0];
}
//---------------------------------------------------------------------------
/*
 * reset fifo
 */
void mpu6050_resetFIFO()
{       if(NeedLog)     Form1->RichEdit1->Lines->Add("resetting FIFO...");
        mpu6050_writeBit(MPU6050_RA_USER_CTRL, MPU6050_USERCTRL_FIFO_RESET_BIT, 1);
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   complete!");
}
//---------------------------------------------------------------------------
/*
 * get gyro offset X
 */
signed char mpu6050_getXGyroOffset()
{       //if(NeedLog)
             Form1->RichEdit1->Lines->Add("getting gyro offset X...");
        mpu6050_readBits(MPU6050_RA_XG_OFFS_TC, MPU6050_TC_OFFSET_BIT, MPU6050_TC_OFFSET_LENGTH);
        //if(NeedLog)
             Form1->RichEdit1->Lines->Add("   gyro offset X: 0x"+IntToHex(Temp8,2));
        return Temp8;
}
//---------------------------------------------------------------------------
/*
 * set gyro offset X
 */
void mpu6050_setXGyroOffset(signed char offset)
{       if(NeedLog)     Form1->RichEdit1->Lines->Add("getting gyro offset X to 0x"+IntToHex(offset,2)+"...");
        mpu6050_writeBits(MPU6050_RA_XG_OFFS_TC, MPU6050_TC_OFFSET_BIT, MPU6050_TC_OFFSET_LENGTH, offset);
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   complete!");
}
//---------------------------------------------------------------------------
/*
 * get gyro offset Y
 */
signed char mpu6050_getYGyroOffset()
{       //if(NeedLog)
                Form1->RichEdit1->Lines->Add("getting gyro offset Y...");
        mpu6050_readBits(MPU6050_RA_YG_OFFS_TC, MPU6050_TC_OFFSET_BIT, MPU6050_TC_OFFSET_LENGTH);
        //if(NeedLog)
                Form1->RichEdit1->Lines->Add("   gyro offset Y: 0x"+IntToHex(Temp8,2));
        return Temp8;
}
//---------------------------------------------------------------------------
/*
 * set gyro offset Y
 */
void mpu6050_setYGyroOffset(signed char offset)
{       if(NeedLog)     Form1->RichEdit1->Lines->Add("setting gyro offset Y to 0x"+IntToHex(offset,2)+"...");
        mpu6050_writeBits(MPU6050_RA_YG_OFFS_TC, MPU6050_TC_OFFSET_BIT, MPU6050_TC_OFFSET_LENGTH, offset);
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   complete!");
}
//---------------------------------------------------------------------------
/*
 * get gyro offset Z
 */
signed char mpu6050_getZGyroOffset()
{       //if(NeedLog)
             Form1->RichEdit1->Lines->Add("getting gyro offset Z...");
        mpu6050_readBits(MPU6050_RA_ZG_OFFS_TC, MPU6050_TC_OFFSET_BIT, MPU6050_TC_OFFSET_LENGTH);
        //if(NeedLog)
             Form1->RichEdit1->Lines->Add("   gyro offset Z: 0x"+IntToHex(Temp8,2));
        return Temp8;
}
//---------------------------------------------------------------------------
/*
 * set gyro offset Z
 */
void mpu6050_setZGyroOffset(signed char offset)
{       if(NeedLog)     Form1->RichEdit1->Lines->Add("setting gyro offset Z to 0x"+IntToHex(offset,2)+"...");
        mpu6050_writeBits(MPU6050_RA_ZG_OFFS_TC, MPU6050_TC_OFFSET_BIT, MPU6050_TC_OFFSET_LENGTH, offset);
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   complete!");
}
//---------------------------------------------------------------------------
/*
 * set sleep disabled
 */
void mpu6050_setSleepDisabled()
{       if(NeedLog)     Form1->RichEdit1->Lines->Add("setting sleep disabled...");
        mpu6050_writeBit(MPU6050_RA_PWR_MGMT_1, MPU6050_PWR1_SLEEP_BIT, 0);
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   complete!");
}
//---------------------------------------------------------------------------
/*
 * set sleep enabled
 */
void mpu6050_setSleepEnabled()
{       if(NeedLog)     Form1->RichEdit1->Lines->Add("setting sleep enabled...");
        mpu6050_writeBit(MPU6050_RA_PWR_MGMT_1, MPU6050_PWR1_SLEEP_BIT, 1);
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   complete!");
}
//---------------------------------------------------------------------------
/*
 * test connection to chip
 */
unsigned char mpu6050_testConnection()
{       Form1->RichEdit1->Lines->Add("testing connection to chip...");
        mpu6050_readBits(MPU6050_RA_WHO_AM_I, MPU6050_WHO_AM_I_BIT, MPU6050_WHO_AM_I_LENGTH);
	if(Temp8 == 0x34)
        {       Form1->RichEdit1->Lines->Add("   connected");
                return 1;
        }
	else
        {       Form1->RichEdit1->Lines->Add("   disconnected");
                return 0;
        }
}
//---------------------------------------------------------------------------
/*
 * initialize the accel and gyro
 */
void mpu6050_init()
{       Form1->RichEdit1->Lines->Add("accel and gyro initialization...");
        //allow mpu6050 chip clocks to start up
        Form1->RichEdit1->Lines->Add("   pause 100 ms");
	Sleep(100);

	//set sleep disabled
	mpu6050_setSleepDisabled();

	//wake up delay needed sleep disabled
        Form1->RichEdit1->Lines->Add("   pause 10 ms");
	Sleep(10);

	//set clock source
	//  it is highly recommended that the device be configured to use one of the gyroscopes (or an external clock source)
	//  as the clock reference for improved stability
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   set XGYRO as the clock source");
	mpu6050_writeBits(MPU6050_RA_PWR_MGMT_1, MPU6050_PWR1_CLKSEL_BIT, MPU6050_PWR1_CLKSEL_LENGTH, MPU6050_CLOCK_PLL_XGYRO);

	//set DLPF bandwidth to 42Hz
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   set DLPF bandwidth to 42 Hz");
	mpu6050_writeBits(MPU6050_RA_CONFIG, MPU6050_CFG_DLPF_CFG_BIT, MPU6050_CFG_DLPF_CFG_LENGTH, MPU6050_DLPF_BW_BYTE);

        //set sample rate
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   set sample rate to 200 Hz");
	mpu6050_writeByte(MPU6050_RA_SMPLRT_DIV, MPU6050_SMPLRT_DIVIDER); //1khz / (1 + 4) = 200Hz

	//set gyro range
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   set gyro range to "+IntToStr(MPU6050_GYRO_FS));
	mpu6050_writeBits(MPU6050_RA_GYRO_CONFIG, MPU6050_GCONFIG_FS_SEL_BIT, MPU6050_GCONFIG_FS_SEL_LENGTH, MPU6050_GYRO_FS);

	//set accel range
        if(NeedLog)     Form1->RichEdit1->Lines->Add("   set accel range to "+IntToStr(MPU6050_ACCEL_FS));
	mpu6050_writeBits(MPU6050_RA_ACCEL_CONFIG, MPU6050_ACONFIG_AFS_SEL_BIT, MPU6050_ACONFIG_AFS_SEL_LENGTH, MPU6050_ACCEL_FS);

        Form1->RichEdit1->Lines->Add("initialization of the accel and gyro success!");
}
//---------------------------------------------------------------------------
unsigned char mpu6050_dmpInitialize()
{       Form1->RichEdit1->Lines->Add("DMP initialization...");
        //setup interrupt
	//MPU6050_DMP_INT0SETUP; //    INT0       

	//reset
        //if(NeedLog)
        Form1->RichEdit1->Lines->Add("device reset");
	mpu6050_writeBit(MPU6050_RA_PWR_MGMT_1, MPU6050_PWR1_DEVICE_RESET_BIT, 1);
        //if(NeedLog)
        Form1->RichEdit1->Lines->Add("   pause 30 ms");
        Sleep(30);//wait after reset

        //disable sleep mode
        Form1->RichEdit1->Lines->Add("disable sleep mode");//added
        mpu6050_setSleepDisabled();

        //set memorybank to 0
        Form1->RichEdit1->Lines->Add("set memory bank to 0");//added
        mpu6050_setMemoryBank(0, 0, 0);

        //get X/Y/Z gyro offsets
        //xgOffset = mpu6050_getXGyroOffset();
        //ygOffset = mpu6050_getYGyroOffset();
        //zgOffset = mpu6050_getZGyroOffset();

        //setting slave 0 address to 0x7F
        //if(NeedLog)     Form1->RichEdit1->Lines->Add("setting slave 0 address to 0x7F...");
	//mpu6050_writeByte(MPU6050_RA_I2C_SLV0_ADDR + 0*3, 0x7F);
        //if(NeedLog)     Form1->RichEdit1->Lines->Add("   complete!");

	//disabling I2C Master mode
        //if(NeedLog)
        Form1->RichEdit1->Lines->Add("disabling I2C master mode...");
	mpu6050_writeBit(MPU6050_RA_USER_CTRL, MPU6050_USERCTRL_I2C_MST_EN_BIT, 0);
        //if(NeedLog)
        Form1->RichEdit1->Lines->Add("   complete!");

	//setting slave 0 address to 0x68 (self)
        //if(NeedLog)
        Form1->RichEdit1->Lines->Add("setting slave 0 address to 0x68 (self)...");
	mpu6050_writeByte(MPU6050_RA_I2C_SLV0_ADDR + 0*3, 0x68);
        //if(NeedLog)
        Form1->RichEdit1->Lines->Add("   complete!");

	//resetting I2C Master control
        //if(NeedLog)
        Form1->RichEdit1->Lines->Add("resetting I2C master mode...");
	mpu6050_writeBit(MPU6050_RA_USER_CTRL, MPU6050_USERCTRL_I2C_MST_RESET_BIT, 1);
        //if(NeedLog)
        Form1->RichEdit1->Lines->Add("   complete!");
        //if(NeedLog)
        Form1->RichEdit1->Lines->Add("   pause 20 ms");
	Sleep(20);

        //load DMP code into memory banks
        for(int cnt=0; cnt < MPU6050_DMP_CODE_SIZE; cnt++)
                TempBigBuffer[cnt]=mpu6050_dmpMemory[cnt];  //       TempBigBuffer

        Form1->RichEdit1->Lines->Add("writing DMP memory...");//added
        if (mpu6050_writeMemoryBlock(MPU6050_DMP_CODE_SIZE, 0, 0, 1, 1) == 1)
        {       Form1->RichEdit1->Lines->Add("   complete!");//added
                if (mpu6050_writeDMPConfigurationSet(MPU6050_DMP_CONFIG_SIZE, 1))
                {       //set clock source
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("set clock source to XGYRO");
                	mpu6050_writeBits(MPU6050_RA_PWR_MGMT_1, MPU6050_PWR1_CLKSEL_BIT, MPU6050_PWR1_CLKSEL_LENGTH, MPU6050_CLOCK_PLL_XGYRO); //  ZGYRO

                	//set DMP and FIFO_OFLOW interrupts enabled
                        //if(NeedLog)     Form1->RichEdit1->Lines->Add("set DMP and FIFO_OFLOW interrupts enabled");
                	//mpu6050_writeByte(MPU6050_RA_INT_ENABLE, 0x12);

                        //set sample rate
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("set sample rate");
                        mpu6050_writeByte(MPU6050_RA_SMPLRT_DIV, MPU6050_SMPLRT_DIVIDER); // 1kHz / (1 + 4) = 200 Hz *** 1kHz / (1 + 9) = 100 Hz

                        //set external frame sync to TEMP_OUT_L[0]
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("set external frame sync to TEMP_OUT_L[0]");
                        mpu6050_writeBits(MPU6050_RA_CONFIG, MPU6050_CFG_EXT_SYNC_SET_BIT, MPU6050_CFG_EXT_SYNC_SET_LENGTH, MPU6050_EXT_SYNC_TEMP_OUT_L);

                        //set DLPF bandwidth to 42Hz
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("set DLPF bandwidth");
                        mpu6050_writeBits(MPU6050_RA_CONFIG, MPU6050_CFG_DLPF_CFG_BIT, MPU6050_CFG_DLPF_CFG_LENGTH, MPU6050_DLPF_BW_BYTE);

                        //set gyro sensitivity to +/- 2000 deg/sec
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("set gyro sensitivity to +/- 2000 deg/sec");
                        mpu6050_writeBits(MPU6050_RA_GYRO_CONFIG, MPU6050_GCONFIG_FS_SEL_BIT, MPU6050_GCONFIG_FS_SEL_LENGTH, MPU6050_GYRO_FS_2000);

                        //set DMP configuration bytes (function unknown)
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("set DMP configuration bytes (function unknown)");
                        mpu6050_writeByte(MPU6050_RA_DMP_CFG_1, 0x03);
                        mpu6050_writeByte(MPU6050_RA_DMP_CFG_2, 0x00);

                        //clear OTP Bank flag
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("clear OTP Bank flag");
                        mpu6050_writeBit(MPU6050_RA_XG_OFFS_TC, MPU6050_TC_OTP_BNK_VLD_BIT, 0);

                        //set X/Y/Z gyro offsets to previous values
                        xgOffset = 0; // 0  !!!     !!!
                        ygOffset = 0; // 0  !!!     !!!
                        zgOffset = -90; // 90 !!!     !!!

                        Form1->RichEdit1->Lines->Add("set X/Y/ZGyroOffset");//added
                        mpu6050_setXGyroOffset(xgOffset);
                        mpu6050_setYGyroOffset(ygOffset);
                        mpu6050_setZGyroOffset(zgOffset);

                        //set X/Y/Z gyro user offsets to zero
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("setting X/Y/Z gyro user offsets to zero...");
                        //mpu6050_writeWords(MPU6050_RA_XG_OFFS_USRH, 1, 0);
                        //mpu6050_writeWords(MPU6050_RA_YG_OFFS_USRH, 1, 0);
                        //mpu6050_writeWords(MPU6050_RA_ZG_OFFS_USRH, 1, 0);
                        //       :
                        TempWriteBuffer[0]=0;   // RH -    
                        TempWriteBuffer[1]=0;   // RL -    
                        mpu6050_writeBytes(MPU6050_RA_XG_OFFS_USRH, 2);
                        mpu6050_writeBytes(MPU6050_RA_YG_OFFS_USRH, 2);
                        mpu6050_writeBytes(MPU6050_RA_ZG_OFFS_USRH, 2);
                        if(NeedLog)     Form1->RichEdit1->Lines->Add("   complete!");

                        unsigned short  TempDataSize;
                        unsigned char   TempBank;
                        unsigned char   TempAddress;
                        int             tmpcnt=0;
                        unsigned char   j;
                        //writing final memory update 1/7 (function unknown)
                        Form1->RichEdit1->Lines->Add("writing final memory update 1/7...");
                        TempBank = mpu6050_dmpUpdates[tmpcnt];
                        TempAddress = mpu6050_dmpUpdates[tmpcnt+1];
                        TempDataSize = mpu6050_dmpUpdates[tmpcnt+2];
                        for(j=0;j<TempDataSize;j++)
                                TempBigBuffer[j] = mpu6050_dmpUpdates[tmpcnt+3+j];
                        mpu6050_writeMemoryBlock(TempDataSize, TempBank, TempAddress, 1, 0);
                        Form1->RichEdit1->Lines->Add("   writing final memory update 1/7 complete!");
                        tmpcnt += (3+TempDataSize);

                        //writing final memory update 2/7 (function unknown)
                        Form1->RichEdit1->Lines->Add("writing final memory update 2/7...");
                        TempBank = mpu6050_dmpUpdates[tmpcnt];
                        TempAddress = mpu6050_dmpUpdates[tmpcnt+1];
                        TempDataSize = mpu6050_dmpUpdates[tmpcnt+2];
                        for(j=0;j<TempDataSize;j++)
                                TempBigBuffer[j] = mpu6050_dmpUpdates[tmpcnt+3+j];
                        mpu6050_writeMemoryBlock(TempDataSize, TempBank, TempAddress, 1, 0);
                        Form1->RichEdit1->Lines->Add("   writing final memory update 2/7 complete!");
                        tmpcnt += (3+TempDataSize);

                        //reset FIFO
                        if(NeedLog)     Form1->RichEdit1->Lines->Add("resetting FIFO...");
                        mpu6050_writeBit(MPU6050_RA_USER_CTRL, MPU6050_USERCTRL_FIFO_RESET_BIT, 1);
                        if(NeedLog)     Form1->RichEdit1->Lines->Add("   resetting FIFO complete!");

                        //reading FIFO count
                        Form1->RichEdit1->Lines->Add("reading FIFO count");//added
                        unsigned char fifoCount = mpu6050_getFIFOCount();

                        //reading current FIFO data
                        Form1->RichEdit1->Lines->Add("reading current FIFO data");//added
                        mpu6050_getFIFOBytes(fifoCount);

                        //setting motion detection threshold to 2
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("setting motion detection threshold to 2...");
                        mpu6050_writeByte(MPU6050_RA_MOT_THR, 2);
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("   complete!");

                        //setting zero-motion detection threshold to 156
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("setting zero-motion detection threshold to 156...");
                        mpu6050_writeByte(MPU6050_RA_ZRMOT_THR, 156);
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("   complete!");

                        //setting motion detection duration to 80
                        Form1->RichEdit1->Lines->Add("setting motion detection duration to 80...");
                        mpu6050_writeByte(MPU6050_RA_MOT_DUR, 80);
                        Form1->RichEdit1->Lines->Add("   complete!");

                        //setting zero-motion detection duration to 0
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("setting zero-motion detection duration to 0...");
                        mpu6050_writeByte(MPU6050_RA_ZRMOT_DUR, 0);
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("   complete!");

                        //reset FIFO
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("resetting FIFO...");
                        mpu6050_writeBit(MPU6050_RA_USER_CTRL, MPU6050_USERCTRL_FIFO_RESET_BIT, 1);
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("   resetting FIFO complete!");

                        //enabling FIFO
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("enabling FIFO...");
                        mpu6050_writeBit(MPU6050_RA_USER_CTRL, MPU6050_USERCTRL_FIFO_EN_BIT, 1);
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("   enabling FIFO complete!");

                        //enabling DMP
                        mpu6050_dmpEnable();

                        //resetting DMP
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("resetting DMP...");
                        mpu6050_writeBit(MPU6050_RA_USER_CTRL, MPU6050_USERCTRL_DMP_RESET_BIT, 1);
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("   resetting DMP complete!");

                        //waiting for FIFO count > 2
                        Form1->RichEdit1->Lines->Add("waiting for FIFO count > 2");//added
                        while ((fifoCount = mpu6050_getFIFOCount()) < 3);

                        //added
                        //reading FIFO data
                        Form1->RichEdit1->Lines->Add("reading FIFO data");//added
                        mpu6050_getFIFOBytes(fifoCount);

                        //writing final memory update 3/7 (function unknown)
                        Form1->RichEdit1->Lines->Add("writing final memory update 3/7...");
                        TempBank = mpu6050_dmpUpdates[tmpcnt];
                        TempAddress = mpu6050_dmpUpdates[tmpcnt+1];
                        TempDataSize = mpu6050_dmpUpdates[tmpcnt+2];
                        for(j=0;j<TempDataSize;j++)
                                TempBigBuffer[j] = mpu6050_dmpUpdates[tmpcnt+3+j];
                        mpu6050_writeMemoryBlock(TempDataSize, TempBank, TempAddress, 1, 0);
                        Form1->RichEdit1->Lines->Add("   writing final memory update 3/7 complete!");
                        tmpcnt += (3+TempDataSize);

                        //writing final memory update 4/7 (function unknown)
                        Form1->RichEdit1->Lines->Add("writing final memory update 4/7...");
                        TempBank = mpu6050_dmpUpdates[tmpcnt];
                        TempAddress = mpu6050_dmpUpdates[tmpcnt+1];
                        TempDataSize = mpu6050_dmpUpdates[tmpcnt+2];
                        for(j=0;j<TempDataSize;j++)
                                TempBigBuffer[j] = mpu6050_dmpUpdates[tmpcnt+3+j];
                        mpu6050_writeMemoryBlock(TempDataSize, TempBank, TempAddress, 1, 0);
                        Form1->RichEdit1->Lines->Add("   writing final memory update 4/7 complete!");
                        tmpcnt += (3+TempDataSize);

                        //writing final memory update 5/7 (function unknown)
                        Form1->RichEdit1->Lines->Add("writing final memory update 5/7...");
                        TempBank = mpu6050_dmpUpdates[tmpcnt];
                        TempAddress = mpu6050_dmpUpdates[tmpcnt+1];
                        TempDataSize = mpu6050_dmpUpdates[tmpcnt+2];
                        for(j=0;j<TempDataSize;j++)
                                TempBigBuffer[j] = mpu6050_dmpUpdates[tmpcnt+3+j];
                        mpu6050_writeMemoryBlock(TempDataSize, TempBank, TempAddress, 1, 0);
                        Form1->RichEdit1->Lines->Add("   writing final memory update 5/7 complete!");
                        tmpcnt += (3+TempDataSize);

                        //reading FIFO data
                        //Form1->RichEdit1->Lines->Add("reading FIFO data");//added
                        //mpu6050_getFIFOBytes(fifoCount);

                        //reading final memory update 6/7 (function unknown)
                        Form1->RichEdit1->Lines->Add("writing final memory update 6/7...");
                        TempBank = mpu6050_dmpUpdates[tmpcnt];
                        TempAddress = mpu6050_dmpUpdates[tmpcnt+1];
                        TempDataSize = mpu6050_dmpUpdates[tmpcnt+2];
                        for(j=0;j<TempDataSize;j++)
                                TempBigBuffer[j] = mpu6050_dmpUpdates[tmpcnt+3+j];
                        mpu6050_writeMemoryBlock(TempDataSize, TempBank, TempAddress, 1, 0);
                        Form1->RichEdit1->Lines->Add("   writing final memory update 6/7 complete!");
                        tmpcnt += (3+TempDataSize);

                        //waiting for FIFO count > 2
                        Form1->RichEdit1->Lines->Add("waiting for FIFO count > 2");//added
                        while ((fifoCount = mpu6050_getFIFOCount()) < 3);

                        //reading FIFO data
                        Form1->RichEdit1->Lines->Add("reading FIFO data");//added
                        mpu6050_getFIFOBytes(fifoCount);

                        //writing final memory update 7/7 (function unknown)
                        Form1->RichEdit1->Lines->Add("writing final memory update 7/7...");
                        TempBank = mpu6050_dmpUpdates[tmpcnt];
                        TempAddress = mpu6050_dmpUpdates[tmpcnt+1];
                        TempDataSize = mpu6050_dmpUpdates[tmpcnt+2];
                        for(j=0;j<TempDataSize;j++)
                                TempBigBuffer[j] = mpu6050_dmpUpdates[tmpcnt+3+j];
                        mpu6050_writeMemoryBlock(TempDataSize, TempBank, TempAddress, 1, 0);
                        Form1->RichEdit1->Lines->Add("   writing final memory update 7/7 complete!");
                        //tmpcnt += (3+TempDataSize);  <---    ,     

                        //disabling DMP (you turn it on later)
                        mpu6050_dmpDisable();

                        //resetting FIFO and clearing INT status one last time
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("resetting FIFO and clearing INT status one last time...");
                        mpu6050_writeBit(MPU6050_RA_USER_CTRL, MPU6050_USERCTRL_FIFO_RESET_BIT, 1);
                        //if(NeedLog)
                        Form1->RichEdit1->Lines->Add("   complete!");
                }
                else
                {       Form1->RichEdit1->Lines->Add("configuration block loading failed!");
                        return 2; // configuration block loading failed
                }
        }
        else
        {       Form1->RichEdit1->Lines->Add("main binary block loading failed!");
                return 1; // main binary block loading failed
        }
        Form1->RichEdit1->Lines->Add("DMP initialization success!");
        return 0; // success
}
//---------------------------------------------------------------------------
/*
 * enable dmp
 */
void mpu6050_dmpEnable()
{       Form1->RichEdit1->Lines->Add("enabling DMP...");
	//MPU6050_DMP_INT0ENABLE; //    INT0  
	mpu6050_writeBit(MPU6050_RA_USER_CTRL, MPU6050_USERCTRL_DMP_EN_BIT, 1);
        Form1->RichEdit1->Lines->Add("   enabling DMP complete!");
}
//---------------------------------------------------------------------------
/*
 * disable dmp
 */
void mpu6050_dmpDisable()
{       Form1->RichEdit1->Lines->Add("disabling DMP...");
	//MPU6050_DMP_INT0DISABLE; //    INT0  
	mpu6050_writeBit(MPU6050_RA_USER_CTRL, MPU6050_USERCTRL_DMP_EN_BIT, 0);
        Form1->RichEdit1->Lines->Add("   disabling DMP complete!");
}
//---------------------------------------------------------------------------
//!!!!! OPEN GL !!!!! OPEN GL !!!!! OPEN GL !!!!! OPEN GL !!!!! OPEN GL !!!!!
//---------------------------------------------------------------------------
bool bSetupPixelFormat(HDC hdc)
{       PIXELFORMATDESCRIPTOR pfd, *ppfd;
        int pixelformat;
        ppfd = &pfd;
        ppfd->nSize = sizeof(PIXELFORMATDESCRIPTOR);
        ppfd->nVersion = 1;
        ppfd->dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
        ppfd->dwLayerMask = PFD_MAIN_PLANE;
        ppfd->iPixelType = PFD_TYPE_RGBA;       //    ( PFD_TYPE_RGBA ,      RGBA - , ,   )
        ppfd->cColorBits = 16;                  //  
        ppfd->cDepthBits = 16;                  //    (Z-Buffer)
        ppfd->cAccumBits = 0;
        ppfd->cStencilBits = 0;                 //    (    )
        if ((pixelformat = ChoosePixelFormat(hdc, ppfd)) == 0)  //  ChoosePixelFormat   ,    ,    
        {       MessageBox(NULL, "ChoosePixelFormat failed", "Error", MB_OK);
                return FALSE;
        }
        if (SetPixelFormat(hdc, pixelformat, ppfd) == FALSE)    //  SetPixelFormat        (dc)
        {       MessageBox(NULL, "SetPixelFormat failed", "Error", MB_OK);
                return FALSE;
        }
        return TRUE;
}
//---------------------------------------------------------------------------
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{ Form1->AutoSize=true;
  PortHandle=INVALID_HANDLE_VALUE;
  Button2->Enabled=false;
  Button1->Enabled=false;
  Button3->Enabled=true;        // SetLogFocus
  Button4->Enabled=false;       // ClearLogFocus
  Button9->Enabled=true;        // I want log
  Button10->Enabled=false;      // I don't want log
  Button11->Enabled=true;       // I need details
  Button12->Enabled=false;      // I don't need details

  MPU6050_SMPLRT_DIVIDER=StrToInt(Edit8->Text);
  MPU6050_DLPF_BW_BYTE=0x03;

  HINSTANCE Dll = LoadLibrary("rh0004.dll");
  if(Dll)       //,   
  {     //  
        ConnectPort = (Func_H_Ch *)GetProcAddress(Dll,"_ConnectPort");
        if(ConnectPort) RichEdit1->Lines->Add("  ConnectPort ");
        else
        {       RichEdit1->Lines->Add("  ConnectPort  ");
                return;
        }

        DisconnectPort = (Func_H_H *)GetProcAddress(Dll,"_DisconnectPort");
        if(DisconnectPort)      RichEdit1->Lines->Add("  DisconnectPort ");
        else
        {       RichEdit1->Lines->Add("  DisconnectPort  ");
                return;
        }

        ResetDevice = (Func_UCh_HB *)GetProcAddress(Dll,"_ResetDevice");
        if(ResetDevice) RichEdit1->Lines->Add("  ResetDevice ");
        else
        {       RichEdit1->Lines->Add("  ResetDevice  ");
                return;
        }

        ReadError = (Func_UCh_H *)GetProcAddress(Dll,"_ReadError");
        if(ReadError)   RichEdit1->Lines->Add("  ReadError ");
        else
        {       RichEdit1->Lines->Add("  ReadError  ");
                return;
        }

        AutosendEn = (Func_UCh_HB *)GetProcAddress(Dll,"_EnableAutoload");
        if(AutosendEn)  RichEdit1->Lines->Add("  AutosendEn ");
        else
        {       RichEdit1->Lines->Add("  AutosendEn  ");
                return;
        }

        AutosendDis = (Func_UCh_HB *)GetProcAddress(Dll,"_DisableAutoload");
        if(AutosendDis) RichEdit1->Lines->Add("  AutosendDis ");
        else
        {       RichEdit1->Lines->Add("  AutosendDis  ");
                return;
        }

        ReadVersion = (Func_UCh_H *)GetProcAddress(Dll,"_ReadVersion");
        if(ReadVersion) RichEdit1->Lines->Add("  ReadVersion ");
        else
        {       RichEdit1->Lines->Add("  ReadVersion  ");
                return;
        }

        SendStart_I2C = (Func_UCh_HB *)GetProcAddress(Dll,"_SendStart_I2C");
        if(SendStart_I2C)       RichEdit1->Lines->Add("  SendStart_I2C ");
        else
        {       RichEdit1->Lines->Add("  SendStart_I2C  ");
                return;
        }

        SendStop_I2C = (Func_UCh_HB *)GetProcAddress(Dll,"_SendStop_I2C");
        if(SendStop_I2C)        RichEdit1->Lines->Add("  SendStop_I2C ");
        else
        {       RichEdit1->Lines->Add("  SendStop_I2C  ");
                return;
        }

        SendByte_I2C = (Func_UI_HBUCh *)GetProcAddress(Dll,"_SendByte_I2C");
        if(SendByte_I2C)        RichEdit1->Lines->Add("  SendByte_I2C ");
        else
        {       RichEdit1->Lines->Add("  SendByte_I2C  ");
                return;
        }

        ReadByteA_I2C = (Func_R_H *)GetProcAddress(Dll,"_ReadByteA_I2C");
        if(ReadByteA_I2C)       RichEdit1->Lines->Add("  ReadByteA_I2C ");
        else
        {       RichEdit1->Lines->Add("  ReadByteA_I2C  ");
                return;
        }

        ReadByte_I2C = (Func_R_H *)GetProcAddress(Dll,"_ReadByte_I2C");
        if(ReadByte_I2C)        RichEdit1->Lines->Add("  ReadByte_I2C ");
        else
        {       RichEdit1->Lines->Add("  ReadByte_I2C  ");
                return;
        }
        //      - 
        RichEdit1->Lines->Add("");      //  
        Button1->Enabled=true;
  }
  else MessageBox(NULL,"   Dll","Error",MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{ PortHandle=ConnectPort((ComboBox1->Text).c_str());
  if(PortHandle!=INVALID_HANDLE_VALUE)
  {     Button1->Enabled=false;
        Button2->Enabled=true;

        if(NeedLogFocus)        RichEdit1->SetFocus();
        else                    Edit1->SetFocus();

        RichEdit1->Lines->Add("   "+ComboBox1->Text);
        RichEdit1->Lines->Add("");      //  
        if(mpu6050_testConnection())
        {       //mpu6050_init();
                //Sleep(50);
                mpu6050_dmpInitialize();
        }
  }
  else
  {     RichEdit1->Lines->Add("     "+ComboBox1->Text);
        RichEdit1->Lines->Add("");      //  
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{ DisconnectPort(PortHandle);
  PortHandle=INVALID_HANDLE_VALUE;
  Button1->Enabled=true;
  Button2->Enabled=false;
  RichEdit1->Lines->Add("  com-");
  RichEdit1->Lines->Add("");      //  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{ if(PortHandle!=INVALID_HANDLE_VALUE)
  {     DisconnectPort(PortHandle);
        RichEdit1->Lines->Add("  com-");
  }
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ReadVersion1Click(TObject *Sender)
{ unsigned char Version;
  if(PortHandle!=INVALID_HANDLE_VALUE)
  {     Version=ReadVersion(PortHandle);
        RichEdit1->Lines->Add(" : 0x"+IntToHex(Version,2));
  }
  else RichEdit1->Lines->Add("  .    .");
  RichEdit1->Lines->Add("");      //  
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{       NeedLogFocus=true;
        Button4->Enabled=true;
        Button3->Enabled=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{       NeedLogFocus=false;
        Button4->Enabled=false;
        Button3->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button9Click(TObject *Sender)
{       NeedLog=true;
        Button10->Enabled=true;
        Button9->Enabled=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button10Click(TObject *Sender)
{       NeedLog=false;
        Button9->Enabled=true;
        Button10->Enabled=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button11Click(TObject *Sender)
{       NEED_DETAILS=true;
        Button11->Enabled=false;      // I need details
        Button12->Enabled=true;       // I don't need details
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button12Click(TObject *Sender)
{       NEED_DETAILS=false;
        Button11->Enabled=true;       // I need details
        Button12->Enabled=false;      // I don't need details
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit8Exit(TObject *Sender)
{       Edit9->Text = 1000/(1+StrToInt(Edit8->Text));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox2Change(TObject *Sender)
{       switch(ComboBox2->ItemIndex)
        {       case 0: MPU6050_DLPF_BW_BYTE = 0x06;
                        break;
                case 1: MPU6050_DLPF_BW_BYTE = 0x05;
                        break;
                case 2: MPU6050_DLPF_BW_BYTE = 0x04;
                        break;
                case 3: MPU6050_DLPF_BW_BYTE = 0x03;
                        break;
                case 4: MPU6050_DLPF_BW_BYTE = 0x02;
                        break;
                case 5: MPU6050_DLPF_BW_BYTE = 0x01;
                        break;
                case 6: MPU6050_DLPF_BW_BYTE = 0x00;
                        break;
                default: MPU6050_DLPF_BW_BYTE = 0x03;
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{       mpu6050_getFIFOCount();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{       mpu6050_getIntStatus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
{       mpu6050_dmpEnable();
        Timer1->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button8Click(TObject *Sender)
{       mpu6050_dmpDisable();
        Timer1->Enabled=false;
        //resetting FIFO and clearing INT status one last time
        Form1->RichEdit1->Lines->Add("resetting FIFO and clearing INT status one last time...");
        mpu6050_writeBit(MPU6050_RA_USER_CTRL, MPU6050_USERCTRL_FIFO_RESET_BIT, 1);
        Form1->RichEdit1->Lines->Add("   complete!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{       // if(mpu6050_getQuaternionWait(&qw, &qx, &qy, &qz))
        // {    mpu6050_getRollPitchYaw(qw, qx, qy, qz, &roll, &pitch, &yaw);
        // }
	// _delay_ms(10);
        unsigned short  Bytes = mpu6050_getFIFOCount();

        if(Bytes<0x2A)  return;
        else if(Bytes>0xFF)
        {       Timer1->Enabled=false;  //  
                mpu6050_dmpDisable();   //  DMP
                //mpu6050_getIntStatus(); //   
                //resetting FIFO and clearing INT status one last time
                Form1->RichEdit1->Lines->Add("resetting FIFO and clearing INT status one last time...");
                mpu6050_writeBit(MPU6050_RA_USER_CTRL, MPU6050_USERCTRL_FIFO_RESET_BIT, 1);
                Form1->RichEdit1->Lines->Add("   complete!");
                //Sleep(10);              // 
                mpu6050_dmpEnable();    //  DMP
                Timer1->Enabled=true;   //  
                return;
        }
        else mpu6050_getFIFOBytes(Bytes); //     FIFO  TempReadBuffer

        //  
        if(TempReadBuffer[0]>>7)        qw = ((TempReadBuffer[0] << 8) + TempReadBuffer[1]-65536)/16384.0f;
        else                            qw = ((TempReadBuffer[0] << 8) + TempReadBuffer[1])/16384.0f;
        if(TempReadBuffer[4]>>7)        qx = ((TempReadBuffer[4] << 8) + TempReadBuffer[5]-65536)/16384.0f;
        else                            qx = ((TempReadBuffer[4] << 8) + TempReadBuffer[5])/16384.0f;
        if(TempReadBuffer[8]>>7)        qy = ((TempReadBuffer[8] << 8) + TempReadBuffer[9]-65536)/16384.0f;
        else                            qy = ((TempReadBuffer[8] << 8) + TempReadBuffer[9])/16384.0f;
        if(TempReadBuffer[12]>>7)       qz = ((TempReadBuffer[12] << 8) + TempReadBuffer[13]-65536)/16384.0f;
        else                            qz = ((TempReadBuffer[12] << 8) + TempReadBuffer[13])/16384.0f;

        //   
        if(TempReadBuffer[16]>>7)       gx = ((TempReadBuffer[16] << 8) + TempReadBuffer[17]-65536)/131.0f;
        else                            gx = ((TempReadBuffer[16] << 8) + TempReadBuffer[17])/131.0f;
        if(TempReadBuffer[20]>>7)       gy = ((TempReadBuffer[20] << 8) + TempReadBuffer[21]-65536)/131.0f;
        else                            gy = ((TempReadBuffer[20] << 8) + TempReadBuffer[21])/131.0f;
        if(TempReadBuffer[24]>>7)       gz = ((TempReadBuffer[24] << 8) + TempReadBuffer[25]-65536)/131.0f;
        else                            gz = ((TempReadBuffer[24] << 8) + TempReadBuffer[25])/131.0f;
        //   1-   
        //gx = (int)(gx * 10.0f) / 10.0f;
        //gy = (int)(gy * 10.0f) / 10.0f;
        //gz = (int)(gz * 10.0f) / 10.0f;


        //   
        if(TempReadBuffer[28]>>7)       ax = ((TempReadBuffer[28] << 8) + TempReadBuffer[29]-65536)/2048.0f;
        else                            ax = ((TempReadBuffer[28] << 8) + TempReadBuffer[29])/2048.0f;
        if(TempReadBuffer[32]>>7)       ay = ((TempReadBuffer[32] << 8) + TempReadBuffer[33]-65536)/2048.0f;
        else                            ay = ((TempReadBuffer[32] << 8) + TempReadBuffer[33])/2048.0f;
        if(TempReadBuffer[36]>>7)       az = ((TempReadBuffer[36] << 8) + TempReadBuffer[37]-65536)/2048.0f;
        else                            az = ((TempReadBuffer[36] << 8) + TempReadBuffer[37])/2048.0f;
        modul_a=sqrt(ax*ax+ay*ay+az*az);
        //   1-   
        //ax = (int)(ax * 10.0f) / 10.0f;
        //ay = (int)(ay * 10.0f) / 10.0f;
        //az = (int)(az * 10.0f) / 10.0f;

        Edit1->Text = FloatToStr(qw);
        Edit2->Text = FloatToStr(qx);
        Edit3->Text = FloatToStr(qy);
        Edit4->Text = FloatToStr(qz);

        Edit10->Text = FloatToStrF(gx,ffFixed,3,3);
        Edit11->Text = FloatToStrF(gy,ffFixed,3,3);
        Edit12->Text = FloatToStrF(gz,ffFixed,3,3);

        Edit13->Text = FloatToStrF(ax,ffFixed,3,3);
        Edit14->Text = FloatToStrF(ay,ffFixed,3,3);
        Edit15->Text = FloatToStrF(az,ffFixed,3,3);
        Edit16->Text = FloatToStrF(modul_a,ffFixed,3,3);

        yaw = (atan2(2*qx*qy - 2*qw*qz, 2*qw*qw + 2*qx*qx - 1))*180.0/M_PI;
        tpitch = 2*qx*qz + 2*qw*qy;
        if(tpitch > 1)    tpitch=1;
        if(tpitch < -1)   tpitch=-1;
        pitch = (-1.0*asin(tpitch))*180.0/M_PI;
        roll = (atan2(2*qy*qz - 2*qw*qx, 2*qw*qw + 2*qz*qz - 1))*180.0/M_PI;

        Edit5->Text = FloatToStrF(yaw,ffFixed,3,1);             //  (Z)
        Edit6->Text = FloatToStrF(pitch,ffFixed,3,1);           //  (X)
        Edit7->Text = FloatToStrF(roll,ffFixed,3,1);            //  (Y)

        if(NeedLog)     RichEdit1->Lines->Add("yaw()="+FloatToStrF(yaw,ffFixed,3,1)+"   pitch()="+FloatToStrF(pitch,ffFixed,3,1)+"   roll()="+FloatToStrF(roll,ffFixed,3,1));

        Draw();

        pyaw = -yaw;       //  
        ppitch = -pitch;
        proll = -roll;
}
//---------------------------------------------------------------------------
//!!!!! OPEN GL !!!!! OPEN GL !!!!! OPEN GL !!!!! OPEN GL !!!!! OPEN GL !!!!!
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{       ghDC = GetDC(Handle);
        if (!bSetupPixelFormat(ghDC))   Close();//   
        ghRC = wglCreateContext(ghDC);          //      
        wglMakeCurrent(ghDC, ghRC);             //    (Rendering Context)
        glClearColor(0.85, 0.85, 0.85, 0.0);    //   (   ),      
                                                //    - 4 ,   RGBA
                                                //     glClearIndex(0.0), -       
        FormResize(Sender);
        //  OpenGL     (  )  glEnable  glDisable
        glEnable(GL_COLOR_MATERIAL);    //     - 
        glEnable(GL_DEPTH_TEST);        //   ,    
        glEnable(GL_LIGHTING);          //  
        glEnable(GL_LIGHT0);            //  < 0>
        float p[4]={3,3,3,1},
              d[3]={-1,-1,-3};
        glLightfv(GL_LIGHT0,GL_POSITION,p);             //   < 0>: 
        glLightfv(GL_LIGHT0,GL_SPOT_DIRECTION,d);       //   
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{       glViewport( 0, 0, Width, Height );      //    - ,   OpenGL    (   -  )
        glMatrixMode( GL_PROJECTION );  //     
                                        //     ,    ,     GL_PROJECTION
                                        //  ,     ,      GL_MODELVIEW
        glLoadIdentity();       //        ( ), ..    
        glOrtho(-5,5, -5,5, 2,12);      //    () ;  ,       
                                        // 6   GLdouble (  double): left, right, bottom, top, near, far 
                                        //   , , , ,     ,
                                        // .. ,     ,    (         )
                                        //      ,   glFrustum  gluPerspective
        gluLookAt(5,5,5, 0,0,0, 0,0,1); //   :   -  ,  -  ,  -   Y
        glMatrixMode( GL_MODELVIEW );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{       if(ghRC)
        {       wglMakeCurrent(ghDC,0);
                wglDeleteContext(ghRC);
        }
        if(ghDC) ReleaseDC(Handle, ghDC);
}
//---------------------------------------------------------------------------
void TForm1::Draw()
{       glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);     //        (        )

        if(RadioButton1->Checked==true) draw_Axis();
        else                            draw_Plane();

        //    
        glRotated(-pyaw, 0,0,1);       //   
        glRotated(proll, 1,0,0);       //   
        glRotated(ppitch, 0,1,0);      //   

        // 
        glRotated(pitch, 0,1,0);       //   
        glRotated(roll, 1,0,0);        //   
        glRotated(-yaw, 0,0,1);        //   

        SwapBuffers(ghDC);              //    
}
//---------------------------------------------------------------------------
void draw_Axis()
{       glLineWidth(3);         //    3

        glBegin(GL_LINES);      //   
        glColor3d(1,0,0);       //  
        glVertex3d(-0.5,0,0);   //  , 
        glVertex3d(1,0,0);      //  
        glColor3d(0,1,0);       // 
        glVertex3d(0,-0.5,0);   //  , 
        glVertex3d(0,1,0);      //  
        glColor3d(0,0,1);       // 
        glVertex3d(0,0,-0.5);   //  , 
        glVertex3d(0,0,1);      //  
        glEnd();                //   
}
//---------------------------------------------------------------------------
void draw_Plane()
{       double  nos       = 0.3,
                fuselaz_l = 1,
                fuselaz_w = 0.1,
                kil_h     = 0.2,
                kil_w     = 0.1,
                motor_l   = 0.7,
                motor_w   = 0.2,
                krilo_l   = 1,
                krilo_w1  = 0.6,
                krilo_w2  = 0.2;

        glLineWidth(1);         //    1
        glColor3d(1,0.5,0.5);           //  

        glBegin(GL_TRIANGLE_FAN);     //   
          glVertex3d(fuselaz_l+nos,0,0);                 // .1
          glVertex3d(fuselaz_l,fuselaz_w,-fuselaz_w);    // .2
          glVertex3d(fuselaz_l,fuselaz_w,fuselaz_w);     // .3
          glVertex3d(fuselaz_l,-fuselaz_w,fuselaz_w);    // .4
          glVertex3d(fuselaz_l,-fuselaz_w,-fuselaz_w);   // .5
          glVertex3d(fuselaz_l,fuselaz_w,-fuselaz_w);    // .2
        glEnd();                //  

        glBegin(GL_QUAD_STRIP); //   
          glVertex3d(fuselaz_l,fuselaz_w,-fuselaz_w);   // .2
          glVertex3d(-fuselaz_l,fuselaz_w,-fuselaz_w);  // .6
          glVertex3d(fuselaz_l,fuselaz_w,fuselaz_w);    // .3
          glVertex3d(-fuselaz_l,fuselaz_w,fuselaz_w);   // .7
          glVertex3d(fuselaz_l,-fuselaz_w,fuselaz_w);   // .4
          glVertex3d(-fuselaz_l,-fuselaz_w,fuselaz_w);  // .8
          glVertex3d(fuselaz_l,-fuselaz_w,-fuselaz_w);  // .5
          glVertex3d(-fuselaz_l,-fuselaz_w,-fuselaz_w); // .9
          glVertex3d(fuselaz_l,fuselaz_w,-fuselaz_w);   // .2
          glVertex3d(-fuselaz_l,fuselaz_w,-fuselaz_w);  // .6
        glEnd();                //  

        glBegin(GL_QUADS);      //   
          glVertex3d(-fuselaz_l+3*kil_w,0,fuselaz_w);    // .10
          glVertex3d(-fuselaz_l,0,-fuselaz_w);           // .11
          glVertex3d(-fuselaz_l-kil_w,0,fuselaz_w+kil_h);// .12
          glVertex3d(-fuselaz_l+kil_w,0,fuselaz_w+kil_h);// .13
        glEnd();                //  

        glBegin(GL_QUAD_STRIP); //    
          glVertex3d(motor_l,fuselaz_w,-fuselaz_w);             // .14
          glVertex3d(-fuselaz_l,fuselaz_w,-fuselaz_w);          // .6
          glVertex3d(motor_l,fuselaz_w+motor_w,-fuselaz_w);     // .15
          glVertex3d(-fuselaz_l,fuselaz_w+motor_w,-fuselaz_w);  // .18
          glVertex3d(motor_l+motor_w,fuselaz_w+motor_w,fuselaz_w);// .16
          glVertex3d(-fuselaz_l,fuselaz_w+motor_w,fuselaz_w);   // .19
          glVertex3d(motor_l+motor_w,fuselaz_w,fuselaz_w);      // .17
          glVertex3d(-fuselaz_l,fuselaz_w,fuselaz_w);           // .7
        glEnd();                //  

        glBegin(GL_QUAD_STRIP); //    
          glVertex3d(motor_l,-fuselaz_w,-fuselaz_w);             // .14'
          glVertex3d(-fuselaz_l,-fuselaz_w,-fuselaz_w);          // .6'
          glVertex3d(motor_l,-fuselaz_w-motor_w,-fuselaz_w);     // .15'
          glVertex3d(-fuselaz_l,-fuselaz_w-motor_w,-fuselaz_w);  // .18'
          glVertex3d(motor_l+motor_w,-fuselaz_w-motor_w,fuselaz_w);// .16'
          glVertex3d(-fuselaz_l,-fuselaz_w-motor_w,fuselaz_w);   // .19'
          glVertex3d(motor_l+motor_w,-fuselaz_w,fuselaz_w);      // .17'
          glVertex3d(-fuselaz_l,-fuselaz_w,fuselaz_w);           // .7'
        glEnd();                //  

        glBegin(GL_POLYGON);    //  
          glVertex3d(krilo_w1,0,fuselaz_w);                     // .22
          glVertex3d(-krilo_w1+krilo_w2,krilo_l,fuselaz_w);     // .23
          glVertex3d(-krilo_w1,krilo_l,fuselaz_w);              // .24
          glVertex3d(-krilo_w1,-krilo_l,fuselaz_w);             // .24'
          glVertex3d(-krilo_w1+krilo_w2,-krilo_l,fuselaz_w);     // .23'
        glEnd();                //  
}
//---------------------------------------------------------------------------

